VERSION 5.00
Begin VB.Form MainWin 
   Caption         =   "Downsample"
   ClientHeight    =   6675
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6840
   LinkTopic       =   "Form1"
   ScaleHeight     =   6675
   ScaleWidth      =   6840
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton SampleBtn 
      Caption         =   "Downsample"
      Height          =   495
      Left            =   5160
      TabIndex        =   2
      Top             =   6000
      Width           =   1575
   End
   Begin VB.Frame DstFrm 
      Caption         =   "Destination"
      Height          =   2655
      Left            =   120
      TabIndex        =   1
      Top             =   3000
      Width           =   6615
      Begin VB.DirListBox DstDir 
         Height          =   1890
         Left            =   120
         TabIndex        =   6
         Top             =   600
         Width           =   6375
      End
      Begin VB.DriveListBox DstDrv 
         Height          =   315
         Left            =   120
         TabIndex        =   4
         Top             =   240
         Width           =   1935
      End
   End
   Begin VB.Frame SrcFrm 
      Caption         =   "Source"
      Height          =   2655
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   6615
      Begin VB.DirListBox SrcDir 
         Height          =   1890
         Left            =   120
         TabIndex        =   5
         Top             =   600
         Width           =   6375
      End
      Begin VB.DriveListBox SrcDrv 
         Height          =   315
         Left            =   120
         TabIndex        =   3
         Top             =   240
         Width           =   1935
      End
   End
End
Attribute VB_Name = "MainWin"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Declare global variable for reference to Canvas application object.
Dim cvApp As Canvas.Application

Private Sub DstDrv_Change()
    ' Set the destination directory path to the selected destination drive.
    DstDir.Path = DstDrv.Drive
End Sub

Private Sub Form_Load()
    ' Create a new Canvas application object.
    Set cvApp = New Canvas.Application
End Sub

Private Sub Form_Unload(Cancel As Integer)
    ' Clean up the application object.
    Set cvApp = Nothing
End Sub

Private Sub SampleBtn_Click()
    Dim fso As New Scripting.FileSystemObject
    Dim srcFile As Scripting.File
    Dim doc As Canvas.Document
    Dim obj As Canvas.DrawObject
    Dim img As Canvas.CVImage
    Dim dstPath As String
    
    ' Set the mouse pointer to an hour glass while the script
    ' is busy.
    Screen.MousePointer = vbHourglass
    
    ' Create a new illustration document.
    Set doc = cvApp.Documents.Add(cvsIllustrationDocument)
    
    ' Loop over all the files in the selected source folder.
    For Each srcFile In fso.GetFolder(SrcDir.Path).Files
        
        ' If the current file is a JPEG file, place it in
        ' the document.
        If (IsJPEGFile(srcFile.Name)) Then
            Set obj = doc.Place(srcFile.Path)
            
            ' Make sure the result of the placement is an image.
            If (obj.Type = cvsImage) Then
            
                ' Get a reference to the image.
                Set img = obj.Image
                
                ' If the resolution of the image is higher than
                ' 72ppi, set it to 72ppi.
                If (img.Resolution > 72) Then
                    img.SetResolution 72, False
                    
                    ' Attach "ds_" (for DownSample) to the front
                    ' of the file name and append the name to the
                    ' destination directory to get the destination
                    ' path.
                    dstPath = DstDir.Path + "\" + "ds_" + srcFile.Name
                    
                    ' Save the downsampled JPEG image to the destination
                    ' path.
                    doc.SaveAs dstPath, cvsJPEGFormat
                    
                End If
            End If
            
            ' Delete the placed object.
            obj.Delete
        
        End If
    Next
    
    ' Reset the mouse pointer to its default shape.
    Screen.MousePointer = vbDefault
    
End Sub

Private Sub SrcDrv_Change()
    ' Set the source directory path to the selected source drive.
    SrcDir.Path = SrcDrv.Drive
End Sub

' Check if a file is a JPEG file.
Private Function IsJPEGFile(fileName As String) As Boolean
    Dim upName As String
    
    IsJPEGFile = False
    
    ' Convert the file name to uppercase.
    upName = UCase$(fileName)
    
    ' Check if the file name contains ".JPG".
    If InStr(1, upName, ".JPG") > 0 Then
        IsJPEGFile = True
    End If
End Function
