' Usage: dwnsmpl.vbs <sourceDirectory> <destinationDirectory>

' Define constants.

Const cvsIllustrationDocument = 1
Const cvsImage = 8
Const cvsJPEGFormat = 10

' Declare variables.

Dim args
Dim srcDir, dstDir, dstPath
Dim cvApp
Dim doc
Dim obj
Dim img
Dim fso
Dim srcFile

' Obtain the Arguments object and check that we have two argumants
' of string type. The first argument is the source and the second
' the destination directory.

Set args = WScript.Arguments

If (args.Count = 2) Then
    srcDir = args.Item(0)
    dstDir = args.Item(1)

    if (VarType(srcDir) = vbString And VarType(dstDir) = vbString) Then

        ' Start Canvas and create an illustration document.

        Set cvApp = CreateObject("Canvas.Application")
        Set doc = cvApp.Documents.Add(cvsIllustrationDocument)

        ' Create a file system object.

        Set fso = CreateObject("Scripting.FileSystemObject")

        ' Loop over all files in the source directory.
	
        For Each srcFile In fso.GetFolder(srcDir).Files
        
            ' Check if the file is a JPEG file by searching for the substring
            ' ".JPEG" in the file name.

            If (InStr(UCase(srcFile.Name), ".JPG")) Then

                ' Place the JPEG file in the Canvas document.

                Set obj = doc.Place(srcFile.Path)

                ' Make sure the result of the placement is an image and obtain
                ' a reference to it.
			
                If (obj.Type = cvsImage) Then
                    Set img = obj.Image

                    ' If the image resolution if higher than 72ppi, set it to
                    ' 72ppi.

                    If (img.Resolution > 72) Then
                        img.SetResolution 72, False

                        ' Attach "ds_" (for DownSample) to the front
                        ' of the file name and append the name to the
                        ' destination directory to get the destination
                        ' path.

                        dstPath = dstDir + "\" + "ds_" + srcFile.Name

                        ' Save the downsampled JPEG image to the destination
                        ' path.

                        doc.SaveAs dstPath, cvsJPEGFormat

                    End If
                End If

                ' Delete the placed object.

                obj.Delete
       
            End If
        Next

        ' Clean up the application object.
	
        Set cvApp = Nothing

    End If
End If
